/*----- PROTECTED REGION ID(Acs16.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        Acs16.cpp
//
// description : C++ source for the Acs16 class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Acs16 are implemented in this file.
//
// project :     avocent acs16
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.12 $
// $Date: 2014-09-10 13:56:57 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <Acs16.h>
#include <Acs16Class.h>
#include "Socket.h"

/*----- PROTECTED REGION END -----*/	//	Acs16.cpp

/**
 *  Acs16 class description:
 *    
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name         |  Method name
//================================================================
//  State                |  Inherited (no method)
//  Status               |  Inherited (no method)
//  DevSerFlush          |  dev_ser_flush
//  DevSerGetNChar       |  dev_ser_get_nchar
//  DevSerReadChar       |  dev_ser_read_char
//  DevSerReadLine       |  dev_ser_read_line
//  DevSerReadNChar      |  dev_ser_read_nchar
//  DevSerReadRaw        |  dev_ser_read_raw
//  DevSerReadRetry      |  dev_ser_read_retry
//  DevSerReadString     |  dev_ser_read_string
//  DevSerSetBaudrate    |  dev_ser_set_baudrate
//  DevSerSetCharLength  |  dev_ser_set_char_length
//  DevSerSetNewline     |  dev_ser_set_newline
//  DevSerSetParameter   |  dev_ser_set_parameter
//  DevSerSetParity      |  dev_ser_set_parity
//  DevSerSetStopbit     |  dev_ser_set_stopbit
//  DevSerSetTimeout     |  dev_ser_set_timeout
//  DevSerWriteChar      |  dev_ser_write_char
//  DevSerWriteString    |  dev_ser_write_string
//  WriteRead            |  write_read
//================================================================

//================================================================
//  Attributes managed is:
//================================================================
//================================================================

namespace Acs16_ns
{
/*----- PROTECTED REGION ID(Acs16::namespace_starting) ENABLED START -----*/

//	static initializations

/*----- PROTECTED REGION END -----*/	//	Acs16::namespace_starting

//--------------------------------------------------------
/**
 *	Method      : Acs16::Acs16()
 *	Description : Constructors for a Tango device
 *                implementing the classAcs16
 */
//--------------------------------------------------------
Acs16::Acs16(Tango::DeviceClass *cl, string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Acs16::constructor_1) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::constructor_1
}
//--------------------------------------------------------
Acs16::Acs16(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Acs16::constructor_2) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::constructor_2
}
//--------------------------------------------------------
Acs16::Acs16(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Acs16::constructor_3) ENABLED START -----*/
	init_device();
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::constructor_3
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::delete_device()
 *	Description : will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Acs16::delete_device()
{
	DEBUG_STREAM << "Acs16::delete_device() " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::delete_device) ENABLED START -----*/
	
	//	Delete device allocated objects
	if(socket)
    {
        delete socket;
        socket = 0;
    }

	/*----- PROTECTED REGION END -----*/	//	Acs16::delete_device
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::init_device()
 *	Description : will be called at device initialization.
 */
//--------------------------------------------------------
void Acs16::init_device()
{
	DEBUG_STREAM << "Acs16::init_device() create device " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::init_device_before) ENABLED START -----*/
	
	//	Initialization before get_device_property() call
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::init_device_before
	

	//	Get the device properties from database
	get_device_property();
	
	/*----- PROTECTED REGION ID(Acs16::init_device) ENABLED START -----*/
	
	//	Initialize device
        
        if(newLineChar<0 || newLineChar>127)
        {
            WARN_STREAM << "Acs16::Acs16() newline char not set properly" << endl;
            set_state(Tango::ALARM);
            set_status("newline char not set properly");
            
            newLineChar = 13;
            DEBUG_STREAM << "Acs16::Acs16() setting to default newline char 0x" << hex << newLineChar << endl;
        }
        else
        {
                DEBUG_STREAM << "Acs16::Acs16() newline char: 0x" << hex << newLineChar << endl;
        }

        if(timeout<0 || timeout>10000)
        {
            WARN_STREAM << "Acs16::Acs16() timeout not set properly" << endl;
            set_state(Tango::ALARM);
            set_status("timeout not set properly");

            timeout = 4000;
            DEBUG_STREAM << "Acs16::Acs16() setting to default timeout to " << timeout << "ms" << endl;
        }
        else
        {
            DEBUG_STREAM << "Acs16::Acs16() timeout " << timeout << "ms" << endl;
        }

        if(bufferSize < SL_MINSTRING || bufferSize > SL_MAXSTRING)
        {
            bufferSize = SL_MAXSTRING;
            DEBUG_STREAM << "Acs16::Acs16() setting to default buffer size to " << bufferSize << endl;
        }
        else
        {
            DEBUG_STREAM << "Acs16::Acs16() buffer size " << bufferSize << endl;
        }

        try
        {
            socket = new Socket(this, hostName, portNumber, timeout, true);
            socket->open_socket();
            set_state(Tango::STANDBY);
            set_status("Acs16::Acs16() connected");
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "SocketException" << endl;
            set_state(Tango::FAULT);
            set_status("Acs16::Acs16() failed to create a device");
        }

	/*----- PROTECTED REGION END -----*/	//	Acs16::init_device
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::get_device_property()
 *	Description : Read database to initialize property data members.
 */
//--------------------------------------------------------
void Acs16::get_device_property()
{
	/*----- PROTECTED REGION ID(Acs16::get_device_property_before) ENABLED START -----*/
	
	//	Initialize property data members
	

	/*----- PROTECTED REGION END -----*/	//	Acs16::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("PortNumber"));
	dev_prop.push_back(Tango::DbDatum("HostName"));
	dev_prop.push_back(Tango::DbDatum("Timeout"));
	dev_prop.push_back(Tango::DbDatum("NewLineChar"));
	dev_prop.push_back(Tango::DbDatum("BufferSize"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);
	
		//	get instance on Acs16Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Acs16Class	*ds_class =
			(static_cast<Acs16Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize PortNumber from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  portNumber;
		else {
			//	Try to initialize PortNumber from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  portNumber;
		}
		//	And try to extract PortNumber value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  portNumber;

		//	Try to initialize HostName from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  hostName;
		else {
			//	Try to initialize HostName from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  hostName;
		}
		//	And try to extract HostName value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  hostName;

		//	Try to initialize Timeout from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  timeout;
		else {
			//	Try to initialize Timeout from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  timeout;
		}
		//	And try to extract Timeout value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  timeout;

		//	Try to initialize NewLineChar from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  newLineChar;
		else {
			//	Try to initialize NewLineChar from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  newLineChar;
		}
		//	And try to extract NewLineChar value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  newLineChar;

		//	Try to initialize BufferSize from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  bufferSize;
		else {
			//	Try to initialize BufferSize from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  bufferSize;
		}
		//	And try to extract BufferSize value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  bufferSize;

	}

	/*----- PROTECTED REGION ID(Acs16::get_device_property_after) ENABLED START -----*/
	
	//	Check device property data members init
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::always_executed_hook()
 *	Description : method always executed before any command is executed
 */
//--------------------------------------------------------
void Acs16::always_executed_hook()
{
	INFO_STREAM << "Acs16::always_executed_hook()  " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::always_executed_hook) ENABLED START -----*/
	
	//	code always executed before all requests
	

	/*----- PROTECTED REGION END -----*/	//	Acs16::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method      : Acs16::read_attr_hardware()
 *	Description : Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Acs16::read_attr_hardware(TANGO_UNUSED(vector<long> &attr_list))
{
	DEBUG_STREAM << "Acs16::read_attr_hardware(vector<long> &attr_list) entering... " << endl;
	/*----- PROTECTED REGION ID(Acs16::read_attr_hardware) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::read_attr_hardware
}


//--------------------------------------------------------
/**
 *	Method      : Acs16::add_dynamic_attributes()
 *	Description : Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Acs16::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Acs16::add_dynamic_attributes) ENABLED START -----*/
	
	//	Add your own code to create and add dynamic attributes if any
	
	/*----- PROTECTED REGION END -----*/	//	Acs16::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command DevSerFlush related method
 *	Description: Flush serial line port according to argin passed.
 *
 *	@param argin flush to do 0=input 1=output 2=both
 */
//--------------------------------------------------------
void Acs16::dev_ser_flush(Tango::DevLong argin)
{
	DEBUG_STREAM << "Acs16::DevSerFlush()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_flush) ENABLED START -----*/
	
	//	Add your own code
	if((argin != 0) && (argin != 1) && (argin != 2))
        {
            WARN_STREAM << "Acs16::dev_ser_flush(): wrong flush mode" << endl;
            set_state(Tango::ALARM);
            set_status("Acs16::dev_ser_flush(): wrong flush mode");
        }

        try
        {
            if((argin == 0) || (argin == 2))
            {
                raw_read_string();
            }
            if((argin == 1) || (argin == 2))
            {
                //TODO: output buffer
            }
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_flush(): socketException trown" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_flush
}
//--------------------------------------------------------
/**
 *	Command DevSerGetNChar related method
 *	Description: Return the number of chars available in receiving buffer
 *
 *	@returns number of char available in receiving buffer
 */
//--------------------------------------------------------
Tango::DevLong Acs16::dev_ser_get_nchar()
{
	Tango::DevLong argout;
	DEBUG_STREAM << "Acs16::DevSerGetNChar()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_get_nchar) ENABLED START -----*/
	
	//	Add your own code
	DEBUG_STREAM << "Acs16::dev_ser_get_nchar(): entering... !" << endl;

	argout = 0;
        try
        {
            argout = socket->left_to_read();
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_get_nchar(): socketException thrown" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

        DEBUG_STREAM << "Acs16::dev_ser_get_nchar(): " << argout << " char available on buffer" << endl;

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_get_nchar
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DevSerReadChar related method
 *	Description: Read an array of characters, the type of read is specified in the
 *               input parameter, it can be SL_RAW SL_NCHAR SL_LINE
 *
 *	@param argin type of read SL_RAW SL_NCHAR SL_LINE
 *	@returns Array of characters read
 */
//--------------------------------------------------------
Tango::DevVarCharArray *Acs16::dev_ser_read_char(Tango::DevLong argin)
{
	Tango::DevVarCharArray *argout;
	DEBUG_STREAM << "Acs16::DevSerReadChar()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_read_char) ENABLED START -----*/
	
	//	Add your own code
	long read_type;
        long nchar;
        long retry;
        string result;

        read_type = argin & 0x000f;

        try
        {
            switch (read_type)
            {
                case SL_RAW:
                    DEBUG_STREAM << "Acs16::dev_ser_read_char() in SL_RAW mode" << endl;
                    result = raw_read_string();
                    break;
                case SL_NCHAR:
                    nchar = argin >> 8;
                    DEBUG_STREAM << "Acs16::dev_ser_read_char() in SL_NCHAR mode, nchar=" << nchar << endl;
                    result = nchar_read_string(nchar);
                    break;
                case SL_LINE:
                    DEBUG_STREAM << "Acs16::dev_ser_read_char() in SL_LINE mode" << endl;
                    result = line_read_string();
                    break;
                case SL_RETRY:
                    retry = argin >> 8;
                    DEBUG_STREAM << "Acs16::dev_ser_read_char() in SL_RETRY mode retry=" << retry << endl;
                    result = retry_read_string(retry);
                    break;
                default:
                    WARN_STREAM << "Acs16::dev_ser_read_char() invalid argument" << endl;
                    set_state(Tango::FAULT);
                    set_status("invalid argument");
                    break;
            }
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_read_char(): socketException thrown" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

	DEBUG_STREAM << "Acs16::dev_ser_read_char(): read " << result << endl;

	argout  = new Tango::DevVarCharArray();
	argout->length(result.length());
        for(unsigned int i=0; i < result.length(); i++)
        {
            (*argout)[i] = result[i];
        }

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_read_char
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DevSerReadLine related method
 *	Description: read a string from the serialline device in mode line (up to
 *               and including the character specified by the NewLine property)
 *
 *	@returns pointer to the string read updated
 */
//--------------------------------------------------------
Tango::DevString Acs16::dev_ser_read_line()
{
	Tango::DevString argout;
	DEBUG_STREAM << "Acs16::DevSerReadLine()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_read_line) ENABLED START -----*/
	
	//	Add your own code
	string result;

        try
        {
            result = line_read_string();
            DEBUG_STREAM << "Acs16::Acs16::dev_ser_read_line(): readed: " << result << endl;
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::Acs16::dev_ser_read_line(): SocketException" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

        argout  = CORBA::string_dup(result.c_str());

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_read_line
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DevSerReadNChar related method
 *	Description: Read a string of N characters from the serial line
 *               If there are no characters to be read returns an empty string.
 *
 *	@param argin number of the caracters to read on the serial line
 *	@returns pointer to the string read updated
 */
//--------------------------------------------------------
Tango::DevString Acs16::dev_ser_read_nchar(Tango::DevLong argin)
{
	Tango::DevString argout;
	DEBUG_STREAM << "Acs16::DevSerReadNChar()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_read_nchar) ENABLED START -----*/
	
	//	Add your own code
	string result;

        try
        {
            result = nchar_read_string(argin);
            DEBUG_STREAM << "Acs16::dev_ser_read_nchar(): readed: " << result << endl;
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_read_nchar(): socketException" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

        argout  = CORBA::string_dup(result.c_str());

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_read_nchar
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DevSerReadRaw related method
 *	Description: read a string from the serialline device in mode raw (no end
 *               of string expected, just empty the entire serialline receiving buffer).
 *
 *	@returns pointer to the string read updated
 */
//--------------------------------------------------------
Tango::DevString Acs16::dev_ser_read_raw()
{
	Tango::DevString argout;
	DEBUG_STREAM << "Acs16::DevSerReadRaw()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_read_raw) ENABLED START -----*/
	
	//	Add your own code
	string result;

        try
        {
            result = raw_read_string();
            DEBUG_STREAM << "Acs16::dev_ser_read_raw(): readed: " << result << endl;
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_read_raw(): socketException" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

        argout  = CORBA::string_dup(result.c_str());

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_read_raw
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DevSerReadRetry related method
 *	Description: read a string from the serialline device in mode raw (no end
 *               of string expected, just empty the entire serialline receiving buffer).
 *               If read successfull, read again "nretry" times.
 *
 *	@param argin number of reading retries
 *	@returns pointer to the string read updated
 */
//--------------------------------------------------------
Tango::DevString Acs16::dev_ser_read_retry(Tango::DevLong argin)
{
	Tango::DevString argout;
	DEBUG_STREAM << "Acs16::DevSerReadRetry()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_read_retry) ENABLED START -----*/
	
	//	Add your own code
	string result;

        try
        {
            result = retry_read_string(argin);            
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_read_retry(): socketException" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

        DEBUG_STREAM << "Acs16::dev_ser_read_retry(): readed: " << result << endl;

        argout  = CORBA::string_dup(result.c_str());

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_read_retry
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DevSerReadString related method
 *	Description: Read a string of characters, the type of read is specified in the
 *               input parameter SL_RAW SL_NCHAR SL_LINE
 *
 *	@param argin type of read SL_RAW SL_NCHAR SL_LINE
 *	@returns String read
 */
//--------------------------------------------------------
Tango::DevString Acs16::dev_ser_read_string(Tango::DevLong argin)
{
	Tango::DevString argout;
	DEBUG_STREAM << "Acs16::DevSerReadString()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_read_string) ENABLED START -----*/
	
	//	Add your own code
	long read_type;
        long nchar;
        long retry;
        string result;

        read_type = argin & 0x000f;
        
        try
        {
            switch (read_type)
            {
                case SL_RAW:
                    DEBUG_STREAM << "Acs16::dev_ser_read_string() in SL_RAW mode" << endl;
                    result = raw_read_string();
                    break;
                case SL_NCHAR:
                    nchar = argin >> 8;
                    DEBUG_STREAM << "Acs16::dev_ser_read_string() in SL_NCHAR mode, nchar=" << nchar << endl;
                    result = nchar_read_string(nchar);
                    break;
                case SL_LINE:
                    DEBUG_STREAM << "Acs16::dev_ser_read_string() in SL_LINE mode" << endl;
                    result = line_read_string();
                    break;
                case SL_RETRY:
                    retry = argin >> 8;
                    DEBUG_STREAM << "Acs16::dev_ser_read_string() in SL_RETRY mode, retray=" << retry << endl;
                    result = retry_read_string(retry);
                    break;
                default:
                    set_state(Tango::ALARM);
                    set_status("unknown type of read, must be SL_RAW, SL_NCHAR, SL_LINE");
                    TangoSys_MemStream out_stream;
                    out_stream << "unknown type of read, must be SL_RAW, SL_NCHAR, SL_LINE" << ends;
                    ERROR_STREAM << "Acs16::dev_ser_read_string() " << out_stream.str() << endl;
                    Tango::Except::throw_exception( (const char *)"Serial::error_argin", out_stream.str(),
                               (const char *)"Acs16::dev_ser_read_string()");
                    break;
            }
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_read_string(): socketException" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }
        
        argout  = CORBA::string_dup(result.c_str());

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_read_string
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DevSerSetBaudrate related method
 *	Description: Sets the new baudrateof the serial line ( up to 4 Mega).
 *               Default is 9600.
 *
 *	@param argin The new baudrate to set
 */
//--------------------------------------------------------
void Acs16::dev_ser_set_baudrate(TANGO_UNUSED(Tango::DevULong argin))
{
	DEBUG_STREAM << "Acs16::DevSerSetBaudrate()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_set_baudrate) ENABLED START -----*/
	
	//	Add your own code
	WARN_STREAM << "Acs16::dev_ser_set_baudrate() not implemented" << endl;
        set_state(Tango::ALARM);
        set_status("call to not implemented method Acs16::dev_ser_set_baudrate()");

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_set_baudrate
}
//--------------------------------------------------------
/**
 *	Command DevSerSetCharLength related method
 *	Description: Sets the new charlength.
 *               0 = 8 bits
 *               1 = 7 bits
 *               2 = 6 bits
 *               3 = 5 bits
 *
 *	@param argin The new charlength to set
 */
//--------------------------------------------------------
void Acs16::dev_ser_set_char_length(TANGO_UNUSED(Tango::DevShort argin))
{
	DEBUG_STREAM << "Acs16::DevSerSetCharLength()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_set_char_length) ENABLED START -----*/
	
	//	Add your own code
	WARN_STREAM << "Acs16::dev_ser_set_char_length() not implemented" << endl;
        set_state(Tango::ALARM);
        set_status("call to not implemented method Acs16::dev_ser_set_char_length()");

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_set_char_length
}
//--------------------------------------------------------
/**
 *	Command DevSerSetNewline related method
 *	Description: The new ending character in hexa.
 *               Default is 0x13 (=CR)
 *
 *	@param argin The new line character to set
 */
//--------------------------------------------------------
void Acs16::dev_ser_set_newline(Tango::DevShort argin)
{
	DEBUG_STREAM << "Acs16::DevSerSetNewline()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_set_newline) ENABLED START -----*/
	
	//	Add your own code
	if(newLineChar<0 || newLineChar>127)
        {
            WARN_STREAM << "Acs16::dev_ser_set_newline() invalid newline char" << endl;
            set_state(Tango::ALARM);
            set_status("invalid newline char: it must be an ASCII 0-127 char");
        }
        else
        {
            newLineChar = argin;
        }

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_set_newline
}
//--------------------------------------------------------
/**
 *	Command DevSerSetParameter related method
 *	Description: Set serial line parameters
 *
 *	@param argin device parameters in pair
 */
//--------------------------------------------------------
void Acs16::dev_ser_set_parameter(TANGO_UNUSED(const Tango::DevVarLongArray *argin))
{
	DEBUG_STREAM << "Acs16::DevSerSetParameter()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_set_parameter) ENABLED START -----*/
	
	//	Add your own code
	WARN_STREAM << "Acs16::dev_ser_set_parameter() not implemented" << endl;
        set_state(Tango::ALARM);
        set_status("call to not implemented method Acs16::dev_ser_set_parameter()");

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_set_parameter
}
//--------------------------------------------------------
/**
 *	Command DevSerSetParity related method
 *	Description: Sets the new parity of the serial line.
 *               NONE 0
 *               ODD 1
 *               EVEN 3
 *
 *	@param argin The new parity to set.
 */
//--------------------------------------------------------
void Acs16::dev_ser_set_parity(TANGO_UNUSED(Tango::DevShort argin))
{
	DEBUG_STREAM << "Acs16::DevSerSetParity()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_set_parity) ENABLED START -----*/
	
	//	Add your own code
	WARN_STREAM << "Acs16::dev_ser_set_parity() not implemented" << endl;
        set_state(Tango::ALARM);
        set_status("call to not implemented method Acs16::dev_ser_set_parity()");

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_set_parity
}
//--------------------------------------------------------
/**
 *	Command DevSerSetStopbit related method
 *	Description: Sets the new stop bit.
 *               0 = none
 *               1 = one stop
 *               2 = 1.5 stop bit
 *
 *	@param argin The new stopbit to set
 */
//--------------------------------------------------------
void Acs16::dev_ser_set_stopbit(TANGO_UNUSED(Tango::DevShort argin))
{
	DEBUG_STREAM << "Acs16::DevSerSetStopbit()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_set_stopbit) ENABLED START -----*/
	
	//	Add your own code
	WARN_STREAM << "Acs16::dev_ser_set_stopbit() not implemented" << endl;
        set_state(Tango::ALARM);
        set_status("call to not implemented method Acs16::dev_ser_set_stopbit()");

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_set_stopbit
}
//--------------------------------------------------------
/**
 *	Command DevSerSetTimeout related method
 *	Description: This command sets the new timeout (in ms).
 *
 *	@param argin Value of the timeout to set
 */
//--------------------------------------------------------
void Acs16::dev_ser_set_timeout(TANGO_UNUSED(Tango::DevShort argin))
{
	DEBUG_STREAM << "Acs16::DevSerSetTimeout()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_set_timeout) ENABLED START -----*/
	
	//	Add your own code
	WARN_STREAM << "Acs16::dev_ser_set_timeout(): not implemented" << endl;
        set_state(Tango::ALARM);
        set_status("call to not implemented method Acs16::dev_ser_set_timeout()");

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_set_timeout
}
//--------------------------------------------------------
/**
 *	Command DevSerWriteChar related method
 *	Description: Write N characters to a seria line and return the
 *               number of characters written.
 *
 *	@param argin Characters to write
 *	@returns Number of characters written
 */
//--------------------------------------------------------
Tango::DevLong Acs16::dev_ser_write_char(const Tango::DevVarCharArray *argin)
{
	Tango::DevLong argout;
	DEBUG_STREAM << "Acs16::DevSerWriteChar()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_write_char) ENABLED START -----*/
	
	//	Add your own code
	argout = 0;
        try
        {
            argout = socket->write((char*)argin->get_buffer(), argin->length());
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_write_char(): socketException" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_write_char
	return argout;
}
//--------------------------------------------------------
/**
 *	Command DevSerWriteString related method
 *	Description: Write a string of characters to a serial line and return
 *               the number of characters written.
 *
 *	@param argin String to write
 *	@returns Number of characters written
 */
//--------------------------------------------------------
Tango::DevLong Acs16::dev_ser_write_string(Tango::DevString argin)
{
	Tango::DevLong argout;
	DEBUG_STREAM << "Acs16::DevSerWriteString()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::dev_ser_write_string) ENABLED START -----*/
	
	//	Add your own code
	argout = 0;
        string input = argin;
        
        try
        {
            argout = socket->write(input.c_str(), input.length());
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_write_string(): socketException" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }

	/*----- PROTECTED REGION END -----*/	//	Acs16::dev_ser_write_string
	return argout;
}
//--------------------------------------------------------
/**
 *	Command WriteRead related method
 *	Description: This method permit to send a request to a device throw the serial line and returns the
 *               response of the device.
 *               The commands write and read don't return until they have not finished.
 *
 *	@param argin type of reading strategy(RAW,NCHAR..),command to write on the port com
 *	@returns response of the device behind the serial line
 */
//--------------------------------------------------------
Tango::DevString Acs16::write_read(const Tango::DevVarLongStringArray *argin)
{
	Tango::DevString argout;
	DEBUG_STREAM << "Acs16::WriteRead()  - " << device_name << endl;
	/*----- PROTECTED REGION ID(Acs16::write_read) ENABLED START -----*/
	
	//	Add your own code
	string result;
        long read_type;
        long nchar;
        long retry;

        dev_ser_flush(2);

        char * input_string;
        input_string = const_cast<char*>(((*argin).svalue[0]).in());
        dev_ser_write_string(input_string);

        read_type = (*argin).lvalue[0] & 0x000f;

        try
        {
            switch (read_type)
            {
              case SL_NCHAR :
                nchar = (*argin).lvalue[0] >> 8;
                DEBUG_STREAM << "Acs16::write_read() in SL_NCHAR mode, nchar=" << nchar << endl;
                result = nchar_read_string(nchar);
                break;
              case SL_LINE :
                DEBUG_STREAM << "Acs16::write_read() in SL_LINE mode" << endl;
                result = line_read_string();
                break;
              case SL_RETRY :
                retry = (*argin).lvalue[0] >> 8;
                DEBUG_STREAM << "Acs16::write_read() in SL_RETRY mode, retray=" << retry << endl;
                result = retry_read_string(retry);
                break;
              default :
                set_state(Tango::ALARM);
                set_status("invalid argument");
                TangoSys_MemStream out_stream;
                out_stream << "unknown type of read, must be SL_NCHAR, SL_LINE, SL_RETRY" << ends;
                ERROR_STREAM << "Acs16::write_read() " << out_stream.str() << endl;
                Tango::Except::throw_exception( (const char *)"Serial::error_argin", out_stream.str(),
                           (const char *)"Acs16::write_read()");
                break;
            }
        }
        catch(SocketException ex)
        {
            WARN_STREAM << "Acs16::dev_ser_write_string(): socketException" << endl;
            set_state(Tango::FAULT);
            set_status("socketException thrown");
        }
        DEBUG_STREAM << "Acs16::write_read() read " << result << endl;

        argout  = CORBA::string_dup(result.c_str());

	/*----- PROTECTED REGION END -----*/	//	Acs16::write_read
	return argout;
}

/*----- PROTECTED REGION ID(Acs16::namespace_ending) ENABLED START -----*/

//	Additional Methods
//+------------------------------------------------------------------
/**
*      Read a string of characters from the serial line.
*                        If string read retry to read "nretry" times.
*                        Specify number of retries.
*      The maximum number of characters that can be read is
*      SL_MAXSTRING, if there are more characters in the received
*      buffer, they are let there for the next read.
*
*      @param  argin: number N of retries
*      @return String read
*/
//+------------------------------------------------------------------
std::string Acs16::retry_read_string(long retry_time)
{
    if(retry_time < 1)
    {
        WARN_STREAM << "Acs16::nchar_read_string() at least one retry" << endl;
        set_state(Tango::ALARM);
        set_status("");
        retry_time = 1;
    }

    char *buffer = (char*)calloc(bufferSize, 1);
    int char_readed = 0;
    int retry_done = 0;
    string result;

    try
    {
	    do
	    {
		char_readed = socket->read(buffer, bufferSize);
		if(char_readed == 0)
		{
		    DEBUG_STREAM << "Acs16::raw_read_string(): no data to read" << endl;
		    break;
		}
		result.append(buffer);
		retry_done++;
		DEBUG_STREAM << "Acs16::raw_read_string(): readed " << char_readed << " char" << endl;
	    }
	    while((retry_done < retry_time) && (static_cast<int>(result.length()) < bufferSize));

	    DEBUG_STREAM << "Acs16::raw_read_string(): result " << result.length() << "/" << bufferSize << " char" << endl;

	    if(result.length() == 0)
	    {
		TangoSys_MemStream out_stream;
		out_stream << "timeout waiting for char to be read" << ends;
		ERROR_STREAM << "Acs16::raw_read_string(): " << out_stream.str() << endl;
		Tango::Except::throw_exception( (const char *)"Serial::error_select",out_stream.str(),
		    (const char *)"Acs16::raw_read_string():");    
	    }
    }
    catch(...)
    {
	    free(buffer);
	    throw;
    }
   
   free(buffer); 
    return result;
}
//+------------------------------------------------------------------
/**
 *      Read a string of characters from the serial line if
 *      there are no characters to be read return an empty string.
 *      The maximum number of characters that can be read is
 *      SL_MAXSTRING, if there are more characters in the received
 *      buffer, they are let there for the next read.
 *
 *      @return String read
 */
//+------------------------------------------------------------------
std::string Acs16::raw_read_string(void)
{
    DEBUG_STREAM << "Acs16::raw_read_string(): entering... !" << endl;

    char *buffer = (char*)calloc(bufferSize, 1);
    int char_readed = 0;

    try
    {
    	char_readed = socket->read(buffer, bufferSize);
    }
    catch(...)
    {
	    free(buffer);
	    throw;
    }

    if(char_readed)
    {
        DEBUG_STREAM << "Acs16::raw_read_string(): readed " << char_readed << " char" << endl;
    }
    else
    {
        DEBUG_STREAM << "Acs16::raw_read_string(): no data to read" << endl;
    }
   
    string ret(buffer);
    free(buffer); 
    return ret;
}
//+------------------------------------------------------------------
/**
 *      Read a string of N characters from the serial line if
 *      there are no characters to be read return an empty string.
 *
 *      @param  argin   number N of characters to read
 *      @return String read
 */
//+------------------------------------------------------------------
std::string Acs16::nchar_read_string(long char_to_read)
{
    DEBUG_STREAM << "Acs16::nchar_read_string(): entering... !" << endl;
    
    if(char_to_read > bufferSize)
    {
        WARN_STREAM << "Acs16::nchar_read_string() reading to many char" << endl;
        set_state(Tango::ALARM);
        set_status("reading to many char");
        char_to_read = bufferSize;
    }

    char *buffer = (char*)calloc(char_to_read, 1);
    int char_readed = 0;

    try
    {
	    char_readed = socket->read(buffer, char_to_read);

	    if(char_readed == char_to_read)
	    {
		DEBUG_STREAM << "Acs16::nchar_read_string(): readed " << char_readed << "/" << char_to_read << " char" << endl;
		buffer[char_readed+1] = 0xd;
	    }
	    else
	    {
		TangoSys_MemStream out_stream;
		out_stream << "timeout waiting for char to be read" << ends;
		ERROR_STREAM << "Acs16::raw_read_string(): " << out_stream.str() << endl;
		Tango::Except::throw_exception( (const char *)"Serial::error_select",out_stream.str(),
		    (const char *)"Acs16::raw_read_string():");
	    }
    }
    catch(...)
    {
	    free(buffer);
	    throw;
    }

    string ret(buffer);
    free(buffer);
    return ret;
}
//+------------------------------------------------------------------
/**
 *      Read a string of characters from the serial line
 *      up and including the next newline.
 *
 *      @return String read
 */
//+------------------------------------------------------------------
std::string Acs16::line_read_string(void)
{
    DEBUG_STREAM << "Acs16::line_read_string(): entering... !" << endl;
    
    //TODO: implement in more efficient way (using double
    //buffering) to do less system calls.
    char c_buffer;
    int char_readed = 0;
    string result;
    bool found = false;

    do
    {
        char_readed = socket->read(&c_buffer, 1);
        if(char_readed == 0)
        {
            DEBUG_STREAM << "Acs16::raw_read_string(): no data to read" << endl;
            break;
        }
        if(c_buffer == newLineChar)
        {
            DEBUG_STREAM << "Acs16::raw_read_string(): new line char found" << endl;
            found = true;
        }
        result.push_back(c_buffer);
        DEBUG_STREAM << "Acs16::raw_read_string(): readed " << char_readed << " char" << endl;
    }
    while(!found && (static_cast<int>(result.length()) < bufferSize));

    if (!found)
    {
        TangoSys_MemStream out_stream;
        out_stream << "timeout waiting for char to be read" << ends;
        ERROR_STREAM << "Acs16::raw_read_string(): " << out_stream.str() << endl;
        Tango::Except::throw_exception( (const char *)"Serial::error_select",out_stream.str(),
            (const char *)"Acs16::raw_read_string():");
    }

    return result;
}


/*----- PROTECTED REGION END -----*/	//	Acs16::namespace_ending
} //	namespace
