/*----- PROTECTED REGION ID(Acs16.h) ENABLED START -----*/
//=============================================================================
//
// file :        Acs16.h
//
// description : Include file for the Acs16 class
//
// project :     avocent acs16
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessio $
//
// $Revision: 1.7 $
// $Date: 2014-09-10 13:33:58 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Acs16_H
#define Acs16_H

#include <tango.h>
#include <omnithread.h>
#include "Socket.h"


const int SL_MAXSTRING = 10240;  /*  10K  */
const int SL_MINSTRING = 1024;

//dev_ser_read_string() input parameter to choose read mode
const int SL_RAW = 0;     /* raw read/write mode */
const int SL_NCHAR = 1;     /* character read/write mode */
const int SL_LINE = 2;     /* line read mode */
const int SL_RETRY = 3;     /* retry read mode */


/*----- PROTECTED REGION END -----*/	//	Acs16.h

/**
 *  Acs16 class description:
 *    
 */

namespace Acs16_ns
{
/*----- PROTECTED REGION ID(Acs16::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations
//

/*----- PROTECTED REGION END -----*/	//	Acs16::Additional Class Declarations

class Acs16 : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Acs16::Data Members) ENABLED START -----*/

//	Add your own data members
public:



/*----- PROTECTED REGION END -----*/	//	Acs16::Data Members

//	Device property data members
public:
	//	PortNumber:	
	Tango::DevLong	portNumber;
	//	HostName:	
	string	hostName;
	//	Timeout:	
	Tango::DevLong	timeout;
	//	NewLineChar:	
	Tango::DevShort	newLineChar;
	//	BufferSize:	
	Tango::DevShort	bufferSize;


//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Acs16(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Acs16(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Acs16(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */	
	~Acs16() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Acs16::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);


	//--------------------------------------------------------
	/**
	 *	Method      : Acs16::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();



//	Command related methods
public:
	/**
	 *	Command DevSerFlush related method
	 *	Description: Flush serial line port according to argin passed.
	 *
	 *	@param argin flush to do 0=input 1=output 2=both
	 */
	virtual void dev_ser_flush(Tango::DevLong argin);
	virtual bool is_DevSerFlush_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerGetNChar related method
	 *	Description: Return the number of chars available in receiving buffer
	 *
	 *	@returns number of char available in receiving buffer
	 */
	virtual Tango::DevLong dev_ser_get_nchar();
	virtual bool is_DevSerGetNChar_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerReadChar related method
	 *	Description: Read an array of characters, the type of read is specified in the
	 *               input parameter, it can be SL_RAW SL_NCHAR SL_LINE
	 *
	 *	@param argin type of read SL_RAW SL_NCHAR SL_LINE
	 *	@returns Array of characters read
	 */
	virtual Tango::DevVarCharArray *dev_ser_read_char(Tango::DevLong argin);
	virtual bool is_DevSerReadChar_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerReadLine related method
	 *	Description: read a string from the serialline device in mode line (up to
	 *               and including the character specified by the NewLine property)
	 *
	 *	@returns pointer to the string read updated
	 */
	virtual Tango::DevString dev_ser_read_line();
	virtual bool is_DevSerReadLine_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerReadNChar related method
	 *	Description: Read a string of N characters from the serial line
	 *               If there are no characters to be read returns an empty string.
	 *
	 *	@param argin number of the caracters to read on the serial line
	 *	@returns pointer to the string read updated
	 */
	virtual Tango::DevString dev_ser_read_nchar(Tango::DevLong argin);
	virtual bool is_DevSerReadNChar_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerReadRaw related method
	 *	Description: read a string from the serialline device in mode raw (no end
	 *               of string expected, just empty the entire serialline receiving buffer).
	 *
	 *	@returns pointer to the string read updated
	 */
	virtual Tango::DevString dev_ser_read_raw();
	virtual bool is_DevSerReadRaw_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerReadRetry related method
	 *	Description: read a string from the serialline device in mode raw (no end
	 *               of string expected, just empty the entire serialline receiving buffer).
	 *               If read successfull, read again "nretry" times.
	 *
	 *	@param argin number of reading retries
	 *	@returns pointer to the string read updated
	 */
	virtual Tango::DevString dev_ser_read_retry(Tango::DevLong argin);
	virtual bool is_DevSerReadRetry_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerReadString related method
	 *	Description: Read a string of characters, the type of read is specified in the
	 *               input parameter SL_RAW SL_NCHAR SL_LINE
	 *
	 *	@param argin type of read SL_RAW SL_NCHAR SL_LINE
	 *	@returns String read
	 */
	virtual Tango::DevString dev_ser_read_string(Tango::DevLong argin);
	virtual bool is_DevSerReadString_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerSetBaudrate related method
	 *	Description: Sets the new baudrateof the serial line ( up to 4 Mega).
	 *               Default is 9600.
	 *
	 *	@param argin The new baudrate to set
	 */
	virtual void dev_ser_set_baudrate(Tango::DevULong argin);
	virtual bool is_DevSerSetBaudrate_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerSetCharLength related method
	 *	Description: Sets the new charlength.
	 *               0 = 8 bits
	 *               1 = 7 bits
	 *               2 = 6 bits
	 *               3 = 5 bits
	 *
	 *	@param argin The new charlength to set
	 */
	virtual void dev_ser_set_char_length(Tango::DevShort argin);
	virtual bool is_DevSerSetCharLength_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerSetNewline related method
	 *	Description: The new ending character in hexa.
	 *               Default is 0x13 (=CR)
	 *
	 *	@param argin The new line character to set
	 */
	virtual void dev_ser_set_newline(Tango::DevShort argin);
	virtual bool is_DevSerSetNewline_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerSetParameter related method
	 *	Description: Set serial line parameters
	 *
	 *	@param argin device parameters in pair
	 */
	virtual void dev_ser_set_parameter(const Tango::DevVarLongArray *argin);
	virtual bool is_DevSerSetParameter_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerSetParity related method
	 *	Description: Sets the new parity of the serial line.
	 *               NONE 0
	 *               ODD 1
	 *               EVEN 3
	 *
	 *	@param argin The new parity to set.
	 */
	virtual void dev_ser_set_parity(Tango::DevShort argin);
	virtual bool is_DevSerSetParity_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerSetStopbit related method
	 *	Description: Sets the new stop bit.
	 *               0 = none
	 *               1 = one stop
	 *               2 = 1.5 stop bit
	 *
	 *	@param argin The new stopbit to set
	 */
	virtual void dev_ser_set_stopbit(Tango::DevShort argin);
	virtual bool is_DevSerSetStopbit_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerSetTimeout related method
	 *	Description: This command sets the new timeout (in ms).
	 *
	 *	@param argin Value of the timeout to set
	 */
	virtual void dev_ser_set_timeout(Tango::DevShort argin);
	virtual bool is_DevSerSetTimeout_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerWriteChar related method
	 *	Description: Write N characters to a seria line and return the
	 *               number of characters written.
	 *
	 *	@param argin Characters to write
	 *	@returns Number of characters written
	 */
	virtual Tango::DevLong dev_ser_write_char(const Tango::DevVarCharArray *argin);
	virtual bool is_DevSerWriteChar_allowed(const CORBA::Any &any);
	/**
	 *	Command DevSerWriteString related method
	 *	Description: Write a string of characters to a serial line and return
	 *               the number of characters written.
	 *
	 *	@param argin String to write
	 *	@returns Number of characters written
	 */
	virtual Tango::DevLong dev_ser_write_string(Tango::DevString argin);
	virtual bool is_DevSerWriteString_allowed(const CORBA::Any &any);
	/**
	 *	Command WriteRead related method
	 *	Description: This method permit to send a request to a device throw the serial line and returns the
	 *               response of the device.
	 *               The commands write and read don't return until they have not finished.
	 *
	 *	@param argin type of reading strategy(RAW,NCHAR..),command to write on the port com
	 *	@returns response of the device behind the serial line
	 */
	virtual Tango::DevString write_read(const Tango::DevVarLongStringArray *argin);
	virtual bool is_WriteRead_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : Acs16::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Acs16::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
protected :	
    Socket* socket;
    std::string raw_read_string(void);
    std::string nchar_read_string(long);
    std::string line_read_string(void);
    std::string retry_read_string(long);

/*----- PROTECTED REGION END -----*/	//	Acs16::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Acs16::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Acs16::Additional Classes Definitions

}	//	End of namespace

#endif   //	Acs16_H
